type automate = {etats : int ; delta : int array array ; final : bool array ; initial : int};;


(*1.a*)

let rec suite x n k = if k = 0 then x else (3321*(suite x n (k-1)) + 5701) mod n;; 

(*autre version qui renvoie le tableau des valeurs ce qui permet par la suite de faire moins de calculs*)
let suite x n max = 
let res = Array.make max 0 in 
res.(0) <- x;
for k = 1 to max -1 do 
res.(k) <- (3321* res.(k-1) + 5701) mod n
done;
res;;


(*1.b*)
let automateEx x n = let delta = Array.make_matrix n 2 0 in 
for q = 0 to (n-1) do
for u = 0 to 1 do
delta.(q).(u) <- (suite x n (2*q + u))
done;
done;
let final = Array.make n false in 
for q = 0 to (n-1) do
if (suite x n q) <= (n/3) then final.(q) <- true
done;
{etats = n ; delta = delta ; final = final ; initial = 0};;


let test = [|automateEx 5 19 ; automateEx 5 503 ; automateEx 16 19 ; automateEx 16 503 |];;

(*1.c*)

let nbTrue t = let compt = ref 0 in 
for i = 0 to (Array.length t) - 1 do 
if t.(i) then incr compt
done;
!compt;;

let nbFinals a = nbTrue a.final;;

nbFinals test.(0);;
nbFinals test.(1);;
nbFinals test.(2);;
nbFinals test.(3);;

(*1.d*)
let cardU a = let compt = ref 0 in
for q = 0 to (a.etats) - 1 do
if a.final.(a.delta.(q).(0)) ||  a.final.(a.delta.(q).(1)) then incr compt
done;
!compt;;

let cardV a = let compt = ref 0 in
for q = 0 to (a.etats) - 1 do
if a.final.(a.delta.(q).(0)) &&  a.final.(a.delta.(q).(1)) then incr compt
done;
!compt;;

cardU test.(0);;
cardU test.(1);;
cardU test.(2);;
cardU test.(3);;

cardV test.(0);;
cardV test.(1);;
cardV test.(2);;
cardV test.(3);;

(*2.a*)
let rec calcul a q u = match u with 
|[] -> q
| x::tl -> calcul a (a.delta.(q).(x)) tl;;

(*2.b*)
let accepte a u = a.final.(calcul a a.initial u);;

(*2.c*)
let nbMots a p = 
let compt = ref 0 in 
let rec aux l m = 
if m = p then
(if (accepte a l) then incr compt else ())
else (aux (0::l) (m+1) ; aux (1 ::l) (m+1))
in 
aux [] 0;
!compt;;

accepte test.(0) [0;1];;

nbMots test.(0) 21;;
nbMots test.(1) 20;;
nbMots test.(2) 20;;
nbMots test.(3) 20;;

(*3.b*)
let nbMots2 a p = 
let n = a.etats in
let t = Array.make_matrix (n) (p+1) 0 in
for q = 0 to (n-1) do 
if a.final.(q) then t.(q).(0) <- 1
done;
for i = 1 to p do
for q = 0 to (n-1) do
t.(q).(i) <- t.(a.delta.(q).(0)).(i-1)+t.(a.delta.(q).(1)).(i-1)
done;
done;
t.(0).(p);;

nbMots2 test.(0) 30;;
nbMots2 test.(1) 20;;
nbMots2 test.(2) 20;;
nbMots2 test.(3) 20;;